VirtualBox Main API

Public Member Functions | Public Attributes | List of all members
IAppliance Interface Reference

Represents a platform-independent appliance in OVF format. More...

Inheritance diagram for IAppliance:

## Public Member Functions
void | read (in wstring file, [retval] out IProgress progress)
| Reads an OVF file into the appliance object. More...
void | interpret ()
| Interprets the OVF data that was read when the appliance was constructed. More...
void | importMachines (in ImportOptions[] options, [retval] out IProgress progress)
| Imports the appliance into VirtualBox by creating instances of IMachine and other interfaces that match the information contained in the appliance as closely as possible, as represented by the import instructions in the virtualSystemDescriptions array. More...
void | createVFSExplorer (in wstring URI, [retval] out IVFSExplorer explorer)
| Returns a IVFSExplorer object for the given URI. More...
void | write (in wstring format, in ExportOptions[] options, in wstring path, [retval] out IProgress progress)
| Writes the contents of the appliance exports into a new OVF file. More...
void | getWarnings ([retval] out wstring[] warnings)
| Returns textual warnings which occurred during execution of interpret. More...
void | getPasswordIds ([retval] out wstring[] identifiers)
| Returns a list of password identifiers which must be supplied to import or export encrypted virtual machines. More...
void | getMediumIdsForPasswordId (in wstring passwordId, [retval] out wstringUUID[] identifiers)
| Returns a list of medium identifiers which use the given password identifier. More...
void | addPasswords (in wstring[] identifiers, in wstring[] passwords)
| Adds a list of passwords required to import or export encrypted virtual machines. More...

## Public Attributes
readonly attribute wstring | path
| Path to the main file of the OVF appliance, which is either the `.ovf` or the `.ova` file passed to read (for import) or write (for export). More...
readonly attribute wstring [] | disks
| Array of virtual disk definitions. More...
readonly attribute IVirtualSystemDescription [] | virtualSystemDescriptions
| Array of virtual system descriptions. More...
readonly attribute wstring [] | machines
| Contains the UUIDs of the machines created from the information in this appliances. More...
readonly attribute ICertificate | certificate
| The X.509 signing certificate, if the imported OVF was signed, `null` if not signed. More...

## Detailed Description

Represents a platform-independent appliance in OVF format.

An instance of this is returned by IVirtualBox::createAppliance, which can then be used to import and export virtual machines within an appliance with VirtualBox.

The OVF standard suggests two different physical file formats:

1. If the appliance is distributed as a set of files, there must be at least one XML descriptor file that conforms to the OVF standard and carries an `.ovf` file extension. If this descriptor file references other files such as disk images, as OVF appliances typically do, those additional files must be in the same directory as the descriptor file.

2. If the appliance is distributed as a single file, it must be in TAR format and have the `.ova` file extension. This TAR file must then contain at least the OVF descriptor files and optionally other files.

   At this time, VirtualBox does not not yet support the packed (TAR) variant; support will be added with a later version.

Importing an OVF appliance into VirtualBox as instances of IMachine involves the following sequence of API calls:

1. Call IVirtualBox::createAppliance. This will create an empty IAppliance object.
2. On the new object, call read with the full path of the OVF file you would like to import. So long as this file is syntactically valid, this will succeed and fill the appliance object with the parsed data from the OVF file.
3. Next, call interpret, which analyzes the OVF data and sets up the contents of the IAppliance attributes accordingly. These can be inspected by a VirtualBox front-end such as the GUI, and the suggestions can be displayed to the user. In particular, the virtualSystemDescriptions array contains instances of IVirtualSystemDescription which represent the virtual systems (machines) in the OVF, which in turn describe the virtual hardware prescribed by the OVF (network and hardware adapters, virtual disk images, memory size and so on). The GUI can then give the user the option to confirm and/or change these suggestions.
4. If desired, call IVirtualSystemDescription::setFinalValues for each virtual system (machine) to override the suggestions made by the interpret routine.
5. Finally, call importMachines to create virtual machines in VirtualBox as instances of IMachine that match the information in the virtual system descriptions. After this call succeeded, the UUIDs of the machines created can be found in the machines array attribute.

Exporting VirtualBox machines into an OVF appliance involves the following steps:

1. As with importing, first call IVirtualBox::createAppliance to create an empty IAppliance object.
2. For each machine you would like to export, call IMachine::exportTo with the IAppliance object you just created. Each such call creates one instance of IVirtualSystemDescription inside the appliance.
3. If desired, call IVirtualSystemDescription::setFinalValues for each virtual system (machine) to override the suggestions made by the IMachine::exportTo routine.
4. Finally, call write with a path specification to have the OVF file written.

Interface ID:
  `{8398F026-4ADD-4474-5BC3-2F9F2140B23E}`

## Member Function Documentation

## ◆ read()

void IAppliance::read | ( | in wstring | file,
|  | [retval] out IProgress | progress
| ) |  |

Reads an OVF file into the appliance object.

This method succeeds if the OVF is syntactically valid and, by itself, without errors. The mere fact that this method returns successfully does not mean that VirtualBox supports all features requested by the appliance; this can only be examined after a call to interpret.

Parameters

  file | Name of appliance file to open (either with an `.ovf` or `.ova` extension, depending on whether the appliance is distributed as a set of files or as a single file, respectively).
  progress | Progress object to track the operation completion.

## ◆ interpret()

void IAppliance::interpret | ( |  | ) |

Interprets the OVF data that was read when the appliance was constructed.

After calling this method, one can inspect the virtualSystemDescriptions array attribute, which will then contain one IVirtualSystemDescription for each virtual machine found in the appliance.

Calling this method is the second step of importing an appliance into VirtualBox; see IAppliance for an overview.

After calling this method, one should call getWarnings to find out if problems were encountered during the processing which might later lead to errors.

## ◆ importMachines()

void IAppliance::importMachines | ( | in ImportOptions [] | options,
|  | [retval] out IProgress | progress
| ) |  |

Imports the appliance into VirtualBox by creating instances of IMachine and other interfaces that match the information contained in the appliance as closely as possible, as represented by the import instructions in the virtualSystemDescriptions array.

Calling this method is the final step of importing an appliance into VirtualBox; see IAppliance for an overview.

Since importing the appliance will most probably involve copying and converting disk images, which can take a long time, this method operates asynchronously and returns an IProgress object to allow the caller to monitor the progress.

After the import succeeded, the UUIDs of the IMachine instances created can be retrieved from the machines array attribute.

Parameters

  options | Options for the importing operation.
  progress | Progress object to track the operation completion.

## ◆ createVFSExplorer()

void IAppliance::createVFSExplorer | ( | in wstring | URI,
|  | [retval] out IVFSExplorer | explorer
| ) |  |

Returns a IVFSExplorer object for the given URI.

Parameters

  URI | The URI describing the file system to use.
  explorer |

## ◆ write()

void IAppliance::write | ( | in wstring | format,
|  | in ExportOptions [] | options,
|  | in wstring | path,
|  | [retval] out IProgress | progress
| ) |  |

Writes the contents of the appliance exports into a new OVF file.

Calling this method is the final step of exporting an appliance from VirtualBox; see IAppliance for an overview.

Since exporting the appliance will most probably involve copying and converting disk images, which can take a long time, this method operates asynchronously and returns an IProgress object to allow the caller to monitor the progress.

Parameters

  format | Output format, as a string. Currently supported formats are "ovf-0.9", "ovf-1.0", "ovf-2.0" and "opc-1.0"; future versions of VirtualBox may support additional formats. The "opc-1.0" format is for creating tarballs for the Oracle Public Cloud.
  options | Options for the exporting operation.
  path | Name of appliance file to create. There are certain restrictions with regard to the file name suffix. If the format parameter is "opc-1.0" a `.tar.gz` suffix is required. Otherwise the suffix must either be `.ovf` or `.ova`, depending on whether the appliance is distributed as a set of files or as a single file, respectively.
  progress | Progress object to track the operation completion.

## ◆ getWarnings()

void IAppliance::getWarnings | ( | [retval] out wstring [] | warnings | ) |

Returns textual warnings which occurred during execution of interpret.

Parameters

  warnings |

## ◆ getPasswordIds()

void IAppliance::getPasswordIds | ( | [retval] out wstring [] | identifiers | ) |

Returns a list of password identifiers which must be supplied to import or export encrypted virtual machines.

Parameters

  identifiers | The list of password identifiers required for export on success.

## ◆ getMediumIdsForPasswordId()

void IAppliance::getMediumIdsForPasswordId | ( | in wstring | passwordId,
|  | [retval] out wstringUUID [] | identifiers
| ) |  |

Returns a list of medium identifiers which use the given password identifier.

Parameters

  passwordId | The password identifier to get the medium identifiers for.
  identifiers | The list of medium identifiers returned on success.

## ◆ addPasswords()

void IAppliance::addPasswords | ( | in wstring [] | identifiers,
|  | in wstring [] | passwords
| ) |  |

Adds a list of passwords required to import or export encrypted virtual machines.

Parameters

  identifiers | List of identifiers.
  passwords | List of matching passwords.

## Member Data Documentation

## ◆ path

readonly attribute wstring IAppliance::path

Path to the main file of the OVF appliance, which is either the `.ovf` or the `.ova` file passed to read (for import) or write (for export).

This attribute is empty until one of these methods has been called.

## ◆ disks

readonly attribute wstring [] IAppliance::disks

Array of virtual disk definitions.

One such description exists for each disk definition in the OVF; each string array item represents one such piece of disk information, with the information fields separated by tab (\t) characters.

The caller should be prepared for additional fields being appended to this string in future versions of VirtualBox and therefore check for the number of tabs in the strings returned.

In the current version, the following eight fields are returned per string in the array:

1. Disk ID (unique string identifier given to disk)
2. Capacity (unsigned integer indicating the maximum capacity of the disk)
3. Populated size (optional unsigned integer indicating the current size of the disk; can be approximate; -1 if unspecified)
4. Format (string identifying the disk format, typically "http://www.vmware.com/specifications/vmdk.html#sparse")
5. Reference (where to find the disk image, typically a file name; if empty, then the disk should be created on import)
6. Image size (optional unsigned integer indicating the size of the image, which need not necessarily be the same as the values specified above, since the image may be compressed or sparse; -1 if not specified)
7. Chunk size (optional unsigned integer if the image is split into chunks; presently unsupported and always -1)
8. Compression (optional string equaling "gzip" if the image is gzip-compressed)

## ◆ virtualSystemDescriptions

readonly attribute IVirtualSystemDescription [] IAppliance::virtualSystemDescriptions

Array of virtual system descriptions.

One such description is created for each virtual system (machine) found in the OVF. This array is empty until either interpret (for import) or IMachine::exportTo (for export) has been called.

## ◆ machines

readonly attribute wstring [] IAppliance::machines

Contains the UUIDs of the machines created from the information in this appliances.

This is only relevant for the import case, and will only contain data after a call to importMachines succeeded.

## ◆ certificate

readonly attribute ICertificate IAppliance::certificate

The X.509 signing certificate, if the imported OVF was signed, `null` if not signed.

This is available after calling read.